<template>
  <div>
    <h1>Link Expired</h1>
    <b-alert
      v-model="showAlert"
      :variant="alertVariety"
      class="mt-2 mb-2"
      dismissible
    >
      {{
        alertMessage
      }}
    </b-alert>
    <p>The link to reset your password has expired. Please try again.</p>
    <p>
      Please enter the username associated with your account and we will email you a link to reset
      your password.
    </p>
    <b-form @submit.prevent="requestPasswordReset">
      <b-form-group
        class="mt-2"
        label=""
      >
        <b-form-input
          v-model="username"
          :disabled="submitting"
          :state="$v.username.$dirty ? ($v.username.$invalid ? false : true) : null"
          placeholder="Enter your username"
          @change="$v.username.$touch"
        />
        <b-form-text v-if="!$v.username.$dirty || !$v.username.$invalid" />
        <b-form-invalid-feedback v-else-if="!$v.username.required">
          Field is required.
        </b-form-invalid-feedback>
      </b-form-group>
      <b-button
        :disabled="$v.username.$invalid || submitting"
        block
        class="mb-2"
        type="submit"
        variant="success"
      >
        <font-awesome-icon
          v-if="submitting"
          icon="spinner"
          pulse
        />
        Reset password
      </b-button>
    </b-form>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import { required } from 'vuelidate/lib/validators';

import { AuthService } from '@/api';

export default Vue.extend({
  data() {
    return {
      alertMessage: '',
      alertVariety: '',
      showAlert: false,
      submitting: false,
      username: '',
    };
  },

  validations: {
    username: {
      required,
    },
  },

  methods: {
    alert(message: string, variety: string) {
      this.alertMessage = message;
      this.alertVariety = variety;
      this.showAlert = true;
    },
    async requestPasswordReset() {
      this.submitting = true;
      try {
        await AuthService.forgotPassword(this.username);
      } catch (error) {
        this.alert(`There was an issue processing your request: ${error}`, 'danger');
        this.$emit('failure');
        return;
      } finally {
        this.submitting = false;
      }
      this.$emit('success');
    },
  },
});
</script>
